<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param vat_value=24 (VAT_VALUE) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
# @url_param currency= (DEFAULT_CURRENCY) 
#
# 
######################################################################

// Debuging
if (isset($_GET['debug'])) {
	$time_start = microtime(true);
	$time = $time_start;
}

// Current datafeed script version
$script_version = "3.08";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed VirtueMart</b><br />";
	echo "script version <b>" . $script_version . "</b><br />";
	exit;
}

// Set no time limit only if php is not running in Safe Mod
if (!@ini_get("safe_mode")) {
   if (function_exists('set_time_limit')) {
		@set_time_limit(0);
	}
	if ((int)substr(@ini_get("memory_limit"), 0, -1) < 512) {
		@ini_set("memory_limit", "512M");
	}
}

ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);

$_SVR = array();

##### Include configuration files ################################################

define ( '_JEXEC', 1 );

define('JPATH_BASE', dirname(__FILE__) );

define( 'DS', DIRECTORY_SEPARATOR );

$hasShipping = false;

if (!file_exists(JPATH_BASE .DS.'includes'.DS.'defines.php')) {
  echo("An include file not found. Check the path.");
}

require_once ( JPATH_BASE .DS.'includes'.DS.'defines.php' );
require_once ( JPATH_BASE .DS.'includes'.DS.'framework.php' );

$mainframe =& JFactory::getApplication('site');
$mainframe->initialise();

require_once 'administrator/components/com_virtuemart/helpers/config.php';
require_once 'administrator/components/com_virtuemart/models/category.php';
require_once 'administrator/components/com_virtuemart/models/product.php';
require_once 'administrator/components/com_virtuemart/models/media.php';
require_once 'administrator/components/com_virtuemart/models/currency.php';
require_once 'administrator/components/com_virtuemart/models/customfields.php';

if(file_exists('administrator/components/com_virtuemart/models/shipmentmethod.php') && JPluginHelper::isEnabled("vmshipment", "weight_countries")) {
  require_once 'administrator/components/com_virtuemart/models/shipmentmethod.php';  
  $hasShipping = true;
}

// Load config
VmConfig::loadConfig();

// Print current Script version
if (@$_GET['get'] == "vm_version") {
	echo "VM version <b>" . vmVersion::$RELEASE . "</b><br />";
	exit;
}

####################################################################

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_availability = (@$_GET['availability'] == "off") ? "off" : "on";
$add_gtin = (@$_GET['gtin'] == "off") ? "off" : "on";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : ((@$_GET['description'] == "limited") ? "limited" : "on");
$show_image = (@$_GET['image'] == "off" || @$_GET['images'] == "off") ? "off" : "on";
$show_manufacturer = (@$_GET['manufacturer'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$use_currency = (@$_GET['currency'] != "") ? strtoupper($_GET['currency']) : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$use_shoppergroup = (@$_GET['use_shoppergroup'] == "off") ? "off" : "on";
$use_path = (@$_GET['usepath'] != "") ? $_GET['usepath'] : "";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";
$limit = (@$_GET['limit'] > 0) ? $_GET['limit'] : "";
$encoding = (@$_GET['encoding'] != "") ? $_GET['encoding'] : "";
$cat_order = (@$_GET['cat_order'] == "on") ? "on" : "off";
$display_currency = (@$_GET['display_currency'] != "") ? $_GET['display_currency'] : "";
$show_combinations = (@$_GET['combinations'] == "on") ? "on" : "off";
$show_attribute = (@$_GET['attribute'] == "on") ? "on" : "off";

####################################################################

// Get system configuration.
$CONFIG = new JConfig();

$base_img_path = JURI::base();
$base_path = ($use_path != "") ? $use_path : (isset($_SERVER['HTTPS']) ? "https://" : "http://") . $_SERVER['HTTP_HOST'];


// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed VirtueMart</b><br />";
	echo "script version <b>" . $script_version . "</b><br />";
	echo "<a href=\"" . $script_basepath . "?get=vm_version" . "\" >Show vm version</a><br /><br /><br />";
	
	/*echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	echo "<b>Discount options</b> - possible values on, off default value on<br />";
	echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	*/
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "<b>VAT value</b> - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";

	echo "<b>Add shipping to datafeed</b> - possible values on, off default value off<br />";
	echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=on" . "\" >" . $script_basepath . "?shipping=on" . "</a><br /><br />";
	
	echo "<b>Add availability to datafeed</b> - possible values on, off default value on<br />";
	echo "availability=on (on,off) <a href=\"" . $script_basepath . "?availability=off" . "\" >" . $script_basepath . "?availability=off" . "</a><br /><br />";
	
	//echo "<b>Add GTIN to datafeed</b> - possible values on, off default value on<br />";
	//echo "gtin=on (on,off) <a href=\"" . $script_basepath . "?gtin=off" . "\" >" . $script_basepath . "?gtin=off" . "</a><br /><br />";

	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
	
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	echo "<b>Display Description options</b> - possible values on, off, limited default value on<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br />";
	echo "<a href=\"" . $script_basepath . "?description=limited" . "\" >" . $script_basepath . "?description=limited" . "</a><br /><br />";
	
	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	echo "<b>Display manufacturer options</b> - possible values on, off default value on<br />";
	echo "manufacturer=on (on,off) <a href=\"" . $script_basepath . "?manufacturer=off" . "\" >" . $script_basepath . "?manufacturer=off" . "</a><br /><br />";
	
	echo "<b>Display currency code</b> - force the display of certain currency code possible values USD,EUR etc. <br />";
	echo "display_currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?display_currency=EUR" . "\" >" . $script_basepath . "?display_currency=EUR" . "</a><br /><br />";
		
	//echo "Special price options - possible values on, off default value on<br />";
	//echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	echo "<b>Show only on stock products</b> - possible values on, off default value off<br />";
	echo "on_stock=off (on,off) <a href=\"" . $script_basepath . "?on_stock=on" . "\" >" . $script_basepath . "?on_stock=on" . "</a><br /><br />";
	
	echo "<b>Show SEO friendly url</b> - possible values on, off default value off<br />";
	echo "sef=off (on,off) <a href=\"" . $script_basepath . "?sef=on" . "\" >" . $script_basepath . "?sef=on" . "</a><br /><br />";
	
	echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	//echo "Get texts in specified language code - possible values en,ro etc. <br />";
	//echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	//echo "Get texts in specified language id - possible values 1,2 etc. <br />";
	//echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	
	echo "<b>Limit displayed products</b> - possible values integer <br />";
	echo "limit=no_limit <a href=\"" . $script_basepath . "?limit=10" . "\" >" . $script_basepath . "?limit=10" . "</a><br /><br />";

	echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
	
	echo "<b>Usepath - force defined basepath to product URL</b> - possible values ex: www.site.com<br />";
	echo "usepath=BASEPATH <a href=\"" . $script_basepath . "?forcepath=on&usepath=http://www.site.com" . "\" >" . $script_basepath . "forcepath=on&usepath=http://www.site.com" . "</a><br /><br />";

	echo "<b>Cat ordering options</b> - possible values on, off default value off<br />";
	echo "cat_order=off (on,off) <a href=\"" . $script_basepath . "?cat_order=on" . "\" >" . $script_basepath . "?cat_order=on" . "</a><br /><br />";
	
	echo "<bShopper group options</b> - possible values on, off default value on<br />";
	echo "use_shoppergroup=on (on,off) <a href=\"" . $script_basepath . "?use_shoppergroup=off" . "\" >" . $script_basepath . "?use_shoppergroup=off" . "</a><br /><br />";
	
	echo "<b>Display product combinations</b> - possible values on, off default value on<br />";
	echo "combinations=off (on,off) <a href=\"" . $script_basepath . "?combinations=on" . "\" >" . $script_basepath . "?combinations=on" . "</a><br /><br />";
	
	echo "<b>Display product attributess</b> - possible values on, off default value off<br />";
	echo "attribute=off (on,off) <a href=\"" . $script_basepath . "?attribute=on" . "\" >" . $script_basepath . "?attribute=on" . "</a><br /><br />";
	
	echo "<br />";
	
	exit;
	
}

// Get currencies rates values
if ($use_currency != "") {

	$file = "cache/daily.xml";

	$xml_parser = xml_parser_create();

	$handle = fopen($file, "r");

	$data = fread($handle, filesize($file));

	fclose($handle);

	xml_parse_into_struct($xml_parser, $data, $vals, $index);
	xml_parser_free($xml_parser);
	
	foreach ($vals as $i=>$v) {
		
		if (($v['tag'] == "RATE") && ($v['type'] == 'complete') && ($v['value'] > 0)) {
			$RATES[$v['attributes']['CURRENCY']] = $v['value'];
		}
		elseif (($v['tag'] == "CUBE") && ($v['type'] == 'complete') && ($v['attributes']['RATE'] > 0)) {
			$RATES[$v['attributes']['CURRENCY']] = $v['attributes']['RATE'];
		}
		
		if ($v['tag'] == "ORIGCURRENCY") {
			$origcurrency = $v['value'];
		}
	}
	
	$origcurrency = ($origcurrency != "") ? $origcurrency : "EUR";
	$RATES[$origcurrency] = 1;
}

$cat = new VirtuemartModelCategory();
$product = new VirtueMartModelProduct();
$image = new VirtueMartModelMedia();
$currency = new VirtueMartModelCurrency();
$combinations = new VirtueMartModelCustomfields();

$config =& JFactory::getConfig();

if($hasShipping && $add_shipping == "on") {
	$shipment = new VirtueMartModelShipmentmethod();
	
	$defaultFrontEndLang = explode("-", $config->getValue('config.language'));
	
	$db = $shipment->getDbo();
	$db->setQuery("SELECT virtuemart_country_id FROM #__virtuemart_countries WHERE country_2_code = '{$defaultFrontEndLang[1]}'");
	$result = $db->loadAssoc();
	$defaultFrontEndCountryCode = $result['virtuemart_country_id'];

	$db->setQuery("SELECT virtuemart_shoppergroup_id FROM #__virtuemart_shoppergroups WHERE `default` = 1");
	$defaultShopperGroup = $db->loadObject();

	$shippings = $shipment->getShipments();
	$availableShippingMethods = array();
  
	if(!empty($shippings) && $shippings !== null) {
		$pattern = '/countries=(\[.*("'.$defaultFrontEndCountryCode.'").*\])?("")?\|zip_start=""\|zip_stop=""\|/';  
		foreach($shippings as $shipping) {    
			if($shipping->published == 1 && preg_match($pattern, $shipping->shipment_params) && (in_array($defaultShopperGroup->virtuemart_shoppergroup_id, $shipping->virtuemart_shoppergroup_ids) || empty($shipping->virtuemart_shoppergroup_ids))) {
				$shipping->nbproducts_start   = preg_replace('/(^.*nbproducts_start=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->nbproducts_stop    = preg_replace('/(^.*nbproducts_stop=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->orderamount_start  = preg_replace('/(^.*orderamount_start=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->orderamount_stop   = preg_replace('/(^.*orderamount_stop=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->package_fee    = preg_replace('/(^.*package_fee=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->free_shipment  = preg_replace('/(^.*free_shipment=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->weight_unit  = preg_replace('/(^.*weight_unit\=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);    
				$shipping->weight_start = preg_replace('/(^.*weight_start=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->weight_stop  = preg_replace('/(^.*weight_stop=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->weight_stop  = preg_replace('/(^.*weight_stop=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->tax_id = preg_replace('/(^.*tax_id=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->cost   = preg_replace('/(^.*cost=")(.*)(".*$)/U', '\\2', $shipping->shipment_params);
				$shipping->price = ($shipping->cost + $shipping->package_fee);

				$db->setQuery("SELECT * FROM jom_virtuemart_calcs as C 
							   WHERE 
								C.virtuemart_calc_id IN (SELECT CC1.virtuemart_calc_id FROM jom_virtuemart_calc_countries as CC1 WHERE CC1.virtuemart_country_id = '{$defaultFrontEndCountryCode}') 
								OR C.virtuemart_calc_id NOT IN (SELECT CC2.virtuemart_calc_id FROM jom_virtuemart_calc_countries as CC2) AND C.virtuemart_calc_id = {$shipping->tax_id}");
				$shipping->tax_data = $db->loadObject();
				$availableShippingMethods[] = $shipping;
			}
		}
	}
}

// Pagination and limit settings
$pagination = "off";

if (isset($_GET['pg']) && @$_GET['pg'] > 0) {
	$_step = ($limit > 0) ? $limit : 1000;
	$_start = ($_GET['pg'] - 1) * $_step;
	$_start = ($_start >= 0) ? $_start : 0;
	$_end = $_start + $_step - 1;
	$pagination = "on";
}

if ($limit > 0 && $pagination == "on") {
	$product->_noLimit = true;
	$nbrReturnProducts = false;
}
elseif ($limit > 0) {
	$product->_noLimit = false;
	$nbrReturnProducts = $limit;
}
else {
	$product->_noLimit = true;
	$nbrReturnProducts = false;
}

// Get product ids
$productIds = $product->sortSearchListQuery ($onlyPublished = TRUE, $product->virtuemart_category_id = FALSE, $group = FALSE, $nbrReturnProducts);

$current_id = 0;
$prod_count = 0;

// Go trough all products
foreach ($productIds as $id) {
	
	// Display products in current page
	if ($pagination == "on" && ($prod_count < $_start || $prod_count > $_end)) {
		$prod_count ++;
		continue;
	}
	
	if ($productItem = $product->getProduct((int)$id, $front = TRUE, $withCalc = TRUE, $onlyPublished = TRUE)) {
	
		if (is_array($productItem->virtuemart_media_id) && !empty($productItem->virtuemart_media_id)) {
			$image->setId($productItem->virtuemart_media_id[0]);
			$image_url = $image->getFile()->file_url;
		} 
		else {
			$image_url = "";
		}
	
		foreach ($productItem->categories as $categoryId) {
			
			// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
			$prod_id = $productItem->virtuemart_product_id;
			
			if ($current_id == $prod_id) {
				continue;
			}
			else {
				$current_id = $prod_id;
			}
			if ( ($show_attribute == "on") || ($show_combinations == "on") ) {
				$ATTR_NAME = array();
				$ATTR_VAL = array();
				$COMB_VAL = array();
				$TMP_VAL = array();
				$VAR_ARR = array();
				$COMB_ARR_VAL = array();
				$COMB_KEYS = array();
				$COMB_ARR_KEYS = array();
				$COMB_ARR = array();
				$COMB_PRICE_ADD = array();
				$COMB_ARR_PRICE = array();
				$attr = "";
				
				$db = JFactory::getDBO();
				// Get the products combnations available for each product
				$db->setQuery("SELECT cgi50_virtuemart_product_customfields.*, cgi50_virtuemart_customs.custom_title 
								FROM cgi50_virtuemart_product_customfields
								LEFT JOIN cgi50_virtuemart_customs ON cgi50_virtuemart_product_customfields.virtuemart_custom_id = cgi50_virtuemart_customs.virtuemart_custom_id
								WHERE virtuemart_product_id = " . $prod_id);
				$VAR_ARR[] = $db->loadAssocList();
				
				if (is_array($VAR_ARR) && sizeof($VAR_ARR) > 0 ) {
					foreach ($VAR_ARR AS $i => $v) { 
						foreach ($v as $k=>$combination) {
							$ATTR_NAME[$combination['virtuemart_custom_id']]= $combination['custom_title'];
							$ATTR_VAL[$combination['virtuemart_custom_id']][$combination['virtuemart_customfield_id']] = $combination['customfield_value'];
							$COMB_VAL[$combination['custom_title']][$combination['virtuemart_customfield_id']] = $combination['customfield_value'];
							$COMB_KEYS[$combination['custom_title']][$combination['virtuemart_customfield_id']] = $combination['virtuemart_customfield_id'];
							$COMB_PRICE_ADD[$combination['custom_title']][$combination['virtuemart_customfield_id']] = $combination['customfield_price'];
						}
					}
				}
				if ($show_attribute == "on") {
					if (is_array($ATTR_VAL) && sizeof($ATTR_VAL) > 0 ) {
						foreach($ATTR_VAL as $i=>$v) {
							$TMP_VAL[$ATTR_NAME[$i]] = join(", ", $v);	
						}
					}
					$tmp = array();
					foreach ($TMP_VAL as $i=>$v) {
						$tmp[] = $i . ": " . $v;
					}
					$attr = join("; ", array_values($tmp));
				}
				
				if ($show_combinations == "on") {
					// combination name
					if (is_array($COMB_VAL) && sizeof($COMB_VAL) > 0 ) {
						$COMB_ARR_VAL = cartesian_product($COMB_VAL);	
						foreach ($COMB_ARR_VAL as $i=>$v) {
							$COMB_ARR[$i]['name'] = join(", ", array_values($v));
						}
					}
					// combination id
					if (is_array($COMB_KEYS) && sizeof($COMB_KEYS) > 0 ) {
						$COMB_ARR_KEYS = cartesian_product($COMB_KEYS);	
						foreach ($COMB_ARR_KEYS as $i=>$v) {
							$COMB_ARR[$i]['variation_id'] = join("_", array_values($v));
						}
					}
					// combination price
					if (is_array($COMB_PRICE_ADD) && sizeof($COMB_PRICE_ADD) > 0 ) {
						$COMB_ARR_PRICE = cartesian_product($COMB_PRICE_ADD);	
						foreach ($COMB_ARR_PRICE as $i=>$v) {
							$COMB_ARR[$i]['price'] = $productItem->prices['salesPrice'] + array_sum($v);
						}
					}
				}
			}

			$cat->setId($categoryId);
			$categoryDetails = $cat->getCategory();
			$parents = $categoryDetails->parents;
			$CATEGORIES_ARR = array();
			while (count($parents) > 0) {
				$CATEGORIES_ARR[] = array_shift($parents)->category_name;
			}
			$categoryName = join(" > ", $CATEGORIES_ARR);
			
			// Currency
			$currency->setId($productItem->product_currency);
			$prod_currency = $currency->getCurrency();

			if (($on_stock_only == "on" && $productItem->product_in_stock > 0) || ((VmConfig::get('stockhandle') == "disableit" && $productItem->product_in_stock > 0) || (VmConfig::get('stockhandle') != "disableit") || (VmConfig::get('stockhandle') == "none"))) {     
				$shippingPrice = null;
				if($hasShipping && is_array($availableShippingMethods) && sizeof($availableShippingMethods) > 0) {        
					foreach($availableShippingMethods as $shipping) {
						$normalizedWeight = ShopFunctions::convertWeigthUnit($productItem->product_weight, $productItem->product_weight_uom, $shipping->weight_unit);
						$weight_check = ($normalizedWeight >= $shipping->weight_start && $normalizedWeight <= $shipping->weight_stop) || ($shipping->weight_start == '' && $normalizedWeight <= $shipping->weight_stop) || ($shipping->weight_stop == '' && $normalizedWeight >= $shipping->weight_start) ||  ($shipping->weight_start == '' &&  $shipping->weight_stop == '');                  
						$price_check = ($productItem->prices['salesPrice'] >= $shipping->orderamount_start && $productItem->prices['salesPrice'] <= $shipping->orderamount_stop) || ($shipping->orderamount_start == '' && $productItem->prices['salesPrice'] <= $shipping->orderamount_stop) || ($productItem->prices['salesPrice'] >= $shipping->orderamount_start && $shipping->orderamount_stop == '') || ($shipping->orderamount_start == '' && $shipping->orderamount_stop == '');            
						$num_check = ($shipping->nbproducts_start <= 1 && $shipping->nbproducts_stop >= 1) || ($shipping->nbproducts_start <= 1 && $shipping->nbproducts_stop == '') || ($shipping->nbproducts_start == '' && $shipping->nbproducts_stop >= 1) || ($shipping->nbproducts_start == '' && $shipping->nbproducts_stop == '');            
						if($weight_check && $price_check && $num_check) {
							if($shipping->free_shipment <= $productItem->prices['salesPrice'] && is_numeric($shipping->free_shipment)) {
								$shippingPrice = "0";
								break;
							} 
							elseif($shipping->price > 0) {
								if(isset($shipping->tax_data->calc_value_mathop)) {
									switch($shipping->tax_data->calc_value_mathop) {
									  case "+" : $shippingPriceWithVAT = $shipping->price + $shipping->tax_data->calc_value;
										break;
									  case "-" : $shippingPriceWithVAT = $shipping->price - $shipping->tax_data->calc_value;
										break;
									  case "+%" : $shippingPriceWithVAT = $shipping->price * (1+$shipping->tax_data->calc_value/100);
										break;
									  case "-%" : $shippingPriceWithVAT-=  $shipping->price -$shipping->price * ($shipping->tax_data->calc_value/100);
										break;                  
									}                
								} 
								else {
									$shippingPriceWithVAT = $shipping->price;
								}

								if($shippingPrice > $shippingPriceWithVAT || $shippingPrice === null) {
									$shippingPrice = $shippingPriceWithVAT;
								}              
							}
						}
					}
				}

				$category_name = $categoryName;
				$prod_manufacturer = ($show_manufacturer == "on") ? $productItem->mf_name : "";
				$prod_model = $productItem->product_sku;
				$prod_name = $productItem->product_name;
				
				if ($show_description == "limited") {
					$prod_desc = substr($productItem->product_desc, 0, 500);
					$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
					$prod_desc = str_replace("\n", " ", $prod_desc);
					$prod_desc = str_replace("\r", "", $prod_desc);
					$prod_desc = strip_tags($prod_desc);
					$prod_desc = substr($prod_desc, 0, 300);
				}
				elseif($show_description == "on") {
					$prod_desc = $productItem->product_desc;
				}
				else {
					$prod_desc = "";
				}

				$prod_url = $base_path . $productItem->link;
				
				// Add GA Tagging parameters to url
				if ($add_tagging == "on") {
					$and_param = (preg_match("/\?/", $prod_url)) ? "&" : "?";
					$prod_url = $prod_url . $and_param . $tagging_params;
				}
				
				$prod_image = ($show_image == "on" && $image_url != "") ? $base_img_path . $image_url : "";
				$prod_price = $productItem->prices['salesPrice'];
				
				// Add VAT to prices
				if ($add_vat == "on") {
					$prod_price = $prod_price * $vat_value;
				}
				
				// Force displayed currency
				$prod_currency_code = ($display_currency != "") ? $display_currency : $prod_currency->currency_code_3;
				
				// Aplly currency exchange
				if ($use_currency != "") {
					// If both currency codes match, do nothing
					if( $prod_currency_code == $use_currency ) {		
						// Continue
					}
					else {
						$valA = $RATES[$prod_currency_code];
						$valB = $RATES[$use_currency];
						$prod_price = ($prod_price * $valB) / $valA;
						
						$prod_currency_code = $use_currency;
					}
				}
				
				$prod_price = round($prod_price, 2);
				
				$shipping_value = ($add_shipping == "on") ? $shippingPrice : "";
				
				if (VmConfig::get('stockhandle') == "none") {
					$availability = "";
				}
				elseif(VmConfig::get('display_stock')) {
					$availability = ($productItem->product_in_stock > 0) ? "In Stock" : "Out of Stock";
				}
				
				// Do not display product
				if (($on_stock_only == "on" || VmConfig::get('stockhandle') == "disableit") && $productItem->product_in_stock == 0) {
					continue;
				}
				
				$gtin = "";
			
				// Clean product name (new lines)
				$prod_name = str_replace("\n", "", strip_tags($prod_name));
				$prod_name = str_replace("\r", "", strip_tags($prod_name));
				$prod_name = str_replace("\t", " ", strip_tags($prod_name));
				
				// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
				$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
				$prod_desc = str_replace("\n", " ", $prod_desc);		
				$prod_desc = str_replace("\r", "", $prod_desc);
				$prod_desc = str_replace("\t", " ", $prod_desc);
				
				// Clean product names and descriptions (separators)
				if ($datafeed_separator == "\t") {
					// Continue... tabs were already removed
				}
				elseif ($datafeed_separator == "|") {
					$prod_name = str_replace("|", " ", strip_tags($prod_name));
					$prod_desc = str_replace("|", " ", $prod_desc);
				}
				else {
					print "Incorrect columns separator.";
					exit;		
				}
			
				// Output the datafeed content
				// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency, Shipping value, Availability, GTIN (UPC/EAN/ISBN) 
				if ($show_combinations == "on" && is_array($COMB_ARR) && sizeof($COMB_ARR) > 0) {
					foreach ($COMB_ARR AS $k => $combination) {
						print  
						$category_name . $datafeed_separator . 
						$prod_manufacturer . $datafeed_separator . 
						$prod_model . $datafeed_separator . 
						$prod_id . "_". $combination['variation_id'] . $datafeed_separator . 
						$prod_name . ", " . $combination['name'] . $datafeed_separator . 
						$prod_desc . $datafeed_separator . 
						$prod_url . $datafeed_separator . 
						$prod_image . $datafeed_separator . 
						$combination['price'] . $datafeed_separator . 
						$prod_currency_code . $datafeed_separator .
						$shipping_value . $datafeed_separator .
						$availability . $datafeed_separator . (($show_attribute == "on") ? $attr . $datafeed_separator . $gtin : $gtin ) . 
						 "\n";
					}
				}
				else {
					
					// Output the datafeed content
					// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency, Shipping value, Availability, GTIN (UPC/EAN/ISBN) 
					print  
					$category_name . $datafeed_separator . 
					$prod_manufacturer . $datafeed_separator . 
					$prod_model . $datafeed_separator . 
					$prod_id . $datafeed_separator . 
					$prod_name . $datafeed_separator . 
					$prod_desc . $datafeed_separator . 
					$prod_url . $datafeed_separator . 
					$prod_image . $datafeed_separator . 
					$prod_price . $datafeed_separator . 
					$prod_currency_code . $datafeed_separator .
					$shipping_value . $datafeed_separator .
					$availability . $datafeed_separator . (($show_attribute == "on") ? $attr . $datafeed_separator . $gtin : $gtin ) . 
					"\n";
				}
				// Debuging
				if (isset($_GET['debug'])) {
					$cnt_prod ++;
					echo $cnt_prod . "."; 
					echo "\t" . number_format(microtime(true) - $time, 3) . "s \n"; 
					$time = microtime(true);
					echo "\t" . number_format(memory_get_usage()/1048576, 3) . "Mb\n\n";
				}
				
				$prod_count++;
		
				// Limit displayed products
				if ($limit > 0 && $prod_count >= $limit && !isset($_GET['pg'])) {
					break;
				}	
			}
		}		
	}
}

// Debuging
if (isset($_GET['debug'])) {
	echo "\npage loaded in " . number_format(microtime(true) - $time_start, 3) . "s \n"; 
	echo "memory limit " . ini_get("memory_limit") . "\n";
	echo "max_execution_time " . ini_get("max_execution_time") . "\n\n";
}

##### Functions ########################################################

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_clean_accents($text){

	$search = array (
		
		"'%C4%99'", #e
		"'%C3%A8'", #e
		"'%C3%A9'", #e
		"'%C3%AA'", #e
		"'%C3%AB'", #e
		"'%C3%89'", #e
		"'%C3%88'", #E
		"'%C3%8A'", #E
		
		"'%C4%85'", #a
		"'%C3%A3'", #a
		"'%C3%A0'", #a
		"'%C3%A4'", #a
		"'%C3%A2'", #a	
		"'%C3%A1'", #a
		"'%C3%A5'", #a
		"'%C3%81'", #A
		"'%C3%82'", #A
		"'%C3%84'", #A
		"'%C3%85'", #A
		"'%C3%80'", #A
		
		"'%C4%87'", #c
		"'%C3%A7'", #c
		"'%C3%87'", #C
		
		"'%C5%9B'", #s
		"'%C5%A1'", #s
		"'%C5%A0'", #S
		"'%C5%9A'", #S
		
		"'%C3%B0'", #d
		"'%C3%B1'", #n
		"'%C3%BD'", #y
		"'%C4%9F'", #g
		
		"'%C4%B1'", #i
		"'%C3%AE'", #i
		"'%C3%AD'", #i
		"'%C3%AF'", #i
		"'%C3%AC'", #i
		"'%C3%8D'", #I
		"'%C3%8E'", #I
		"'%C4%B0'", #I
		
		"'%C5%82'", #l
		
		"'%C5%84'", #n
		
		"'%C3%BA'", #u
		"'%C3%BB'", #u
		"'%C3%B9'", #u
		"'%C3%BC'", #u
		"'%C5%B1'", #u
		
		"'%C3%9C'", #U
		
		"'%C3%B4'", #o
		"'%C3%B3'", #o
		"'%C3%91'", #o
		"'%C3%B6'", #o
		"'%C5%91'", #o
		"'%C3%B2'", #o
		"'%C3%B5'", #o
		"'%C3%93'", #O
		"'%C3%96'", #O
		
		"'%C3%9F'", #ss
		"'%C5%BC'", #z
		"'%C5%BA'", #z
		"'%C5%BB'", #Z
		
		"'%C3%A6'", #ae
		"'%C3%B8'", #oe
		
		"'%C2%AE'",
		"'%C2%B4'",
		"'%E2%84%A2'",
		
	);
	
	$replace = array (
		
		"e",
		"e",
		"e",
		"e",
		"e",
		"e",
		"E",
		"E",
		
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"a",
		"A",
		"A",
		"A",
		"A",
		"A",
		
		"c",
		"c",
		"C",
		
		"s",
		"s",
		"S",
		"S",
		
		"d",
		"n",
		"y",
		"g",
		
		"i",
		"i",
		"i",
		"i",
		"i",
		"I",
		"I",
		"I",
		
		"l",
		
		"n",
		
		"u",
		"u",
		"u",
		"u",
		"u",
		
		"U",
		
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"o",
		"O",
		"O",
		
		"ss",
		"z",
		"z",
		"Z",
		
		"ae",
		"oe",
		
		"",
		"",
		"",
		
	);
	
	$text = preg_replace($search, $replace, $text);
	
	return $text;

}

// Cleans strings
function smfeed_string_clean_search($string){
	
	$trans = get_html_translation_table(HTML_ENTITIES);
	$trans = array_flip ($trans);
	$string = strtr($string, $trans);
	
	$search = array (
		"','",
		"'&quot;'",
		"'&lt;'",
		"'&gt;'",
		"'%&pound;'",
		"'%&euro;'",
		"'-'",
		"'~'",
		"'!'",
		"'\?'",
		"'@'",
		"'#'",
		"'\\$'",
		"'%'",
		"'\^'",
		"'&'",
		"'\*'",
		"'\('",
		"'\)'",
		"'_'",
		"'='",
		"'\''",
		"'\['",
		"'\]'",
		"'{'",
		"'}'",
		"'\|'",
		"'\"'",
		"':'",
		"';'",
		"'\\\'",
		"'>'",
		"'<'",		
		"'[\r]+'",
		"'[\n]+'",
		"'[\t]+'",
		"'[\s]+'",
		//"'\.'",
		//"'\+'",
		//"'/'",
	);
	
	$replace = array (
		"",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		" ",
		//" ",
		//" ",
		//" ",
	);
	
	$string = preg_replace($search, $replace, $string);
	
	return $string;
	
}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

function cartesian_product($set) {
	
	if (!$set) {
		return array(array());
	}
	
	$subset = array_shift($set);
	
	$cartesianSubset = cartesian_product($set);

	$result = array();
	foreach ($subset as $value) {
		foreach ($cartesianSubset as $p) {
			
			array_unshift($p, $value);
			$result[] = $p;
		}
	}
	return $result;        
}



###################################################################

exit;

?>